> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/optimization/optimize.md).

# Optimize & compress PDFs in Xamarin

Learn how to optimize and compress PDF files using the latest technology. Reduce file size by removing redundant information and compressing data streams with pdftron.PDF.Optimizer. Explore advanced c

{% hint style="warning" %}
For Android, available in the full version of the library only. See [Apryse full or standard?](/xamarin/get-started/faq/full-vs-standard.md)
{% endhint %}

To optimize a PDF with default settings.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc doc = new PDFDoc(filename);
Optimizer.Optimize(doc);
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Compress & optimize PDF files](/xamarin/get-started/samples.md#optimizer) Full code sample which shows how to use 'pdftron.PDF.Optimizer' to reduce PDF file size by removing redundant information and compressing data streams using the latest in image compression technology.

## About optimize and compress

Compression as a subset of optimization represents encoding specific data using fewer bits than the original content by reducing the size of the data. This is distinct from optimize (which modifies all images) because you have the ability to choose individual images and to selectively choose the compression type for each.

Apryse SDK supports all basic and advanced compression filters allowed in PDF including:

* JPEG2000
* JBIG2
* CCITT Fax
* Flate/PNG
* JPEG/DCT
* Crypt Filters

## Compress images in a PDF document

To compress images using JBIG2 compression inside a PDF.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc pdf_doc = new PDFDoc(filename);
SDFDoc cos_doc = pdf_doc.GetSDFDoc();
int num_objs = cos_doc.XRefSize();
for (int i=1; i<num_objs; ++i)
{
	Obj obj = cos_doc.GetObj(i);
	if (obj==null || obj.IsFree() || !obj.IsStream())
		continue;

	// Process only images
	DictIterator itr = obj.Find("Subtype");
	if (!itr.HasNext() || itr.Value().GetName() != "Image")
		continue;

	pdftron.PDF.Image input_image = new pdftron.PDF.Image(obj);

	// Process only gray-scale images
	if (input_image.GetComponentNum() != 1) 
		continue; 
	
	int bpc = input_image.GetBitsPerComponent();
	if (bpc != 1) // Recompress 1 BPC images
		continue;

	// Skip images that are already compressed using JBIG2
	itr = obj.Find("Filter");
	if (itr.HasNext() && itr.Value().IsName() && itr.Value().GetName() == "JBIG2Decode")
		continue;
	
	FilterReader reader = new FilterReader(obj.GetDecodedStream());

	ObjSet hint_set = new ObjSet();
	Obj hint = hint_set.CreateArray();
	hint.PushBackName("JBIG2");
	hint.PushBackName("Lossless");
	hint.PushBackName("Threshold");
	hint.PushBackNumber(0.4);
	hint.PushBackName("SharePages");
	hint.PushBackNumber(10000);

	pdftron.PDF.Image new_image = pdftron.PDF.Image.Create(
		cos_doc,
		reader, 							
		input_image.GetImageWidth(),
		input_image.GetImageHeight(),
		1,
		ColorSpace.CreateDeviceGray(),
		hint  // A hint to image encoder to use JBIG2 compression
	);
	cos_doc.Swap(i, new_image.GetSDFObj().GetObjNum());
}
```

{% endcode %}
{% endtab %}
{% endtabs %}

[PDF image JBIG2 compression](/xamarin/get-started/samples.md#jbigtest) Full sample code which illustrates how to recompress bitonal (black and white) images in existing PDF documents using JBIG2 compression.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/xamarin/optimization/optimize.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
